SystemOrganization addCategory: #ConfigurationOfRenoirSt!

Object subclass: #ConfigurationOfRenoirSt
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfRenoirSt'!

!ConfigurationOfRenoirSt commentStamp: 'GabrielOmarCotelli 4/4/2014 00:02' prior: 0!
Metacello configuration for RenoirSt
!

!ConfigurationOfRenoirSt class methodsFor: 'development support' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfRenoirSt class methodsFor: 'private' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfRenoirSt class methodsFor: 'catalog' stamp: 'GabrielOmarCotelli 4/4/2014 00:02'!
catalogChangeLog
	"Returns a paragraph describing the most important changes in the configuration class."
	^ 'Version 1.2.0:
- Issue #30 Added units for frequencies, time, angles, additional relative length and resolution units. Added support for calc(), attr() and toggle()
- Issue #32 Added many font related properties and values
- Issue #37 Added border-radius: and background-size: properties (Thanks Maximiliano Tabacman)
- Updated Tutorial'! !

!ConfigurationOfRenoirSt class methodsFor: 'catalog' stamp: 'GabrielOmarCotelli 2/26/2014 18:51'!
catalogContactInfo
	"Returns a paragraph describing contact information such as email, mailing lists and website."
	^ 'This project is managed in GitHub: https://github.com/gcotelli/RenoirSt.'! !

!ConfigurationOfRenoirSt class methodsFor: 'catalog' stamp: 'GabrielOmarCotelli 2/26/2014 18:49'!
catalogDescription
	"Returns a paragraph describing the project"
	^ 'A DSL enabling programmatic cascading style sheet generation for Pharo Smalltalk.'! !

!ConfigurationOfRenoirSt class methodsFor: 'catalog' stamp: 'GabrielOmarCotelli 4/4/2014 00:02'!
catalogKeyClassesAndExample
	"Returns a paragraph or more describing the key classes of your project. You can use Pillar/Pier syntax to layout out the text i.e., ==Code== and - for bullet."
	^ 'From the end user perspective the single point of entry is the class ==CascadingStyleSheetBuilder==.
Check-out the online tutorial'! !

!ConfigurationOfRenoirSt class methodsFor: 'catalog' stamp: 'GabrielOmarCotelli 2/26/2014 18:50'!
catalogKeywords
	"Returns an array of symbols"
	^ #(web css dsl) ! !

!ConfigurationOfRenoirSt class methodsFor: 'private' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfRenoirSt class methodsFor: 'private' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfRenoirSt class methodsFor: 'metacello tool support' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfRenoirSt class methodsFor: 'loading' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfRenoirSt class methodsFor: 'loading' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfRenoirSt class methodsFor: 'loading' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfRenoirSt class methodsFor: 'accessing' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
project

	^self new project! !

!ConfigurationOfRenoirSt class methodsFor: 'development support' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfRenoirSt methodsFor: 'baselines' stamp: 'GabrielOmarCotelli 3/11/2014 08:17'!
baseline100: spec
	<version: '1.0.0-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://smalltalkhub.com/mc/gcotelli/RenoirSt/main/'.
			spec
				package: #RenoirSt;
				package: #'RenoirSt-HTML' with: [ spec requires: 'RenoirSt' ];
				package: #'RenoirSt-HTML-Tests' with: [ spec requires: 'RenoirSt-HTML' ];
				package: #'RenoirSt-Tests' with: [ spec requires: 'RenoirSt' ].
			spec
				group: 'Minimal' with: #('RenoirSt' 'RenoirSt-HTML');
				group: 'default' with: #('Minimal' 'RenoirSt-Tests' 'RenoirSt-HTML-Tests') ]! !

!ConfigurationOfRenoirSt methodsFor: 'baselines' stamp: 'GabrielOmarCotelli 3/17/2014 09:37'!
baseline110: spec
	<version: '1.1.0-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://smalltalkhub.com/mc/gcotelli/RenoirSt/main/'.
			spec
				package: #RenoirSt;
				package: #'RenoirSt-HTML' with: [ spec requires: 'RenoirSt' ];
				package: #'RenoirSt-HTML-Tests' with: [ spec requires: 'RenoirSt-HTML' ];
				package: #'RenoirSt-Tests' with: [ spec requires: 'RenoirSt' ].
			self baseline110ForUnitsCompatibility: spec ]! !

!ConfigurationOfRenoirSt methodsFor: 'private' stamp: 'GabrielOmarCotelli 3/17/2014 18:10'!
baseline110ForUnitsCompatibility: spec
	spec package: #'RenoirSt-UnitsCompatibility' with: [ spec requires: 'RenoirSt' ].
	spec
		for: #UnitsIsPresent
		do: [ 
			spec
				group: 'Minimal' with: #('RenoirSt' 'RenoirSt-HTML' 'RenoirSt-UnitsCompatibility');
				group: 'default' with: #('Minimal' 'RenoirSt-Tests' 'RenoirSt-HTML-Tests');
				yourself ].
	spec
		for: #UnitsIsAbsent
		do: [ 
			spec
				group: 'Minimal' with: #('RenoirSt' 'RenoirSt-HTML');
				group: 'default' with: #('Minimal' 'RenoirSt-Tests' 'RenoirSt-HTML-Tests');
				yourself ]! !

!ConfigurationOfRenoirSt methodsFor: 'accessing' stamp: 'GabrielOmarCotelli 3/14/2014 14:08'!
customProjectAttributes

	Smalltalk at: #UnitValue ifPresent: [ :class | ^ #(#'UnitsIsLoaded') ].
	^ #( #'UnitsIsAbsent')! !

!ConfigurationOfRenoirSt methodsFor: 'symbolic versions' stamp: 'GabrielOmarCotelli 3/11/2014 08:14'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1.0-baseline'.
! !

!ConfigurationOfRenoirSt methodsFor: 'accessing' stamp: 'GabrielOmarCotelli 2/26/2014 18:45'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfRenoirSt methodsFor: 'symbolic versions' stamp: 'GabrielOmarCotelli 4/4/2014 00:01'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'pharo3.x' version: '1.2.0'.
! !

!ConfigurationOfRenoirSt methodsFor: 'versions' stamp: 'GabrielOmarCotelli 3/11/2014 08:19'!
version100: spec
	<version: '1.0.0' imports: #('1.0.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'First official release'.
		spec author: 'GabrielOmarCotelli'.
		spec timestamp: '3/10/2014 00:02'.
		spec 
			package: #RenoirSt with: 'RenoirSt-GabrielOmarCotelli.23';
			package: #'RenoirSt-HTML' with: 'RenoirSt-HTML-GabrielOmarCotelli.3';
			package: #'RenoirSt-HTML-Tests' with: 'RenoirSt-HTML-Tests-GabrielOmarCotelli.3';
			package: #'RenoirSt-Tests' with: 'RenoirSt-Tests-GabrielOmarCotelli.17'. ].
! !

!ConfigurationOfRenoirSt methodsFor: 'versions' stamp: 'GabrielOmarCotelli 3/17/2014 18:10'!
version110: spec
	<version: '1.1.0' imports: #('1.1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #stable.
			spec
				description:
					'Version 1.1.0:
- Issue #17 Added support for comments
- Issue #2 Improved formatting of rules inside media query
- Issue #7 Improved formula notation support in selectors
- Issue #21 Compatibility with Units package
- Issue #23 Fixed typo: Lenght must be Length
- Updated Tutorial'.
			spec author: 'GabrielOmarCotelli'.
			spec timestamp: '3/17/2014 00:00'.
			spec
				package: #RenoirSt with: 'RenoirSt-GabrielOmarCotelli.28';
				package: #'RenoirSt-HTML' with: 'RenoirSt-HTML-GabrielOmarCotelli.3';
				package: #'RenoirSt-HTML-Tests' with: 'RenoirSt-HTML-Tests-GabrielOmarCotelli.4';
				package: #'RenoirSt-Tests' with: 'RenoirSt-Tests-GabrielOmarCotelli.22';
				package: #'RenoirSt-UnitsCompatibility' with: 'RenoirSt-UnitsCompatibility-GabrielOmarCotelli.1' ]! !

!ConfigurationOfRenoirSt methodsFor: 'versions' stamp: 'GabrielOmarCotelli 4/4/2014 00:01'!
version120: spec
	<version: '1.2.0' imports: #('1.1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #stable.
			spec
				description:
					'Version 1.2.0:
- Issue #30 Added units for frequencies, time, angles, additional relative length and resolution units. Added support for calc(), attr() and toggle()
- Issue #32 Added many font related properties and values
- Issue #37 Added border-radius: and background-size: properties (Thanks Maximiliano Tabacman)
- Updated Tutorial'.
			spec author: 'GabrielOmarCotelli'.
			spec timestamp: '4/4/2014 00:00'.
			spec
				package: #RenoirSt with: 'RenoirSt-GabrielOmarCotelli.32';
				package: #'RenoirSt-HTML' with: 'RenoirSt-HTML-GabrielOmarCotelli.3';
				package: #'RenoirSt-HTML-Tests' with: 'RenoirSt-HTML-Tests-GabrielOmarCotelli.4';
				package: #'RenoirSt-Tests' with: 'RenoirSt-Tests-GabrielOmarCotelli.26';
				package: #'RenoirSt-UnitsCompatibility' with: 'RenoirSt-UnitsCompatibility-GabrielOmarCotelli.2' ]! !
